
<style>
.slidernewpower {
  width: 500px;
}

.btn {
  border: none;
  color: white;
  padding: 14px 28px;
  font-size: 16px;
  cursor: pointer;
}

.success {background-color: #4CAF50;} /* Green */
.success:hover {background-color: #46a049;}

.info {background-color: #2196F3;} /* Blue */
.info:hover {background: #0b7dda;}

.warning {background-color: #ff9800;} /* Orange */
.warning:hover {background: #e68a00;}

.danger {background-color: #f44336;} /* Red */
.danger:hover {background: #da190b;}

.default {background-color: #e7e7e7; color: black;} /* Gray */
.default:hover {background: #ddd;}
</style>

<title>IS0GRB Patch IP Camera configuration help</title>
<meta name="description" content="IS0GRB Patch IP Camera configuration help">
<link type="text/css" href="./img/style.css" rel="stylesheet">
  <script src="lib/jquery-3.5.1.min.js"></script>
  <script src="lib/socket.io-2.3.0.min.js"></script>
  <script src="lib/u16Websocket.js"></script>
</head>

<body>
<header id="top">
<div class="anchor">
<section style=" text-align:left;">
<div><h3><b>IS0GRB Pluto DATV Patch - Guida configurazione IP Camera per modalità beacon</b></h3></div>
</section>
<br><hr>
<section>
<div>Per poter configurare una camera IP che supporta normalmente il protocollo RTSP è necessario disporre di un ricevitore Octagon SF8008 o di un Raspberry<br>
Configurazioni preliminari: Impostare IP statico ed installare FFMPEG fra i pacchetti aggiuntivi del ricevitore. Di default non è installato sul firmware OpenATV<br>
Di seguito un esempio nel caso si utilizzi il ricevitore Octagon SF8008<br>
Effettuare il login sul ricevitore in SSH:<br><br>
login: root<br>
passwd: (premere ENTER)<br><br>
# <i><b>cd /etc/init.d</b></i><br>
# <i><b>touch check-ipcamera.sh</b></i><br>
# <i><b>chmod 755 check-ipcamera.sh</b></i><br>
# <i><b>vi check-ipcamera.sh</b></i><br><br>

Inserire ora questi comandi all'interno del file check-ipcamera.sh:<br>
<br><hr>

#!/bin/sh<br><br>

pidffmpeg=$(ps aux | grep ffmpeg | grep -v grep)<br>
if [ "$pidffmpeg" = "" ] ; then<br>
killall ffmpeg<br>
/usr/bin/ffmpeg -y -rtsp_transport tcp -i rtsp://192.168.1.80:554/11 -vcodec copy -acodec copy -f mpegts udp://192.168.1.101:8282<br>
fi<br>
exit<br>

<br><hr>

-(192.168.1.80 è l'IP della camera)<br>
-(192.168.1.101 è l'IP del pluto collegato via LAN)<br>
-(rtsp://192.168.1.80:554/11 è l'indirizzo dello streaming della camera IP)<br>
-(l'esempio si riferisce ad una camera IP marca SV3C modello B06POE-1080-HX)<br>
-(In questo sito e' possibile ricavare l'indirizzo dello streaming in base alla propria telecamera SV3C: https://www.ispyconnect.com/camera/sv3c)<br>

Salvataggio del file:<br>
Premere 2 volte ESC e digitare :wq<br><br>

<br><hr><br>

# <i><b>cd /etc</b></i><br>
# <i><b>vi crontab</b></i><br><br>

Aggiungere questa riga in /etc/crontab:<br><br>

* * * * * root /home/root/check-ipcamera.sh<br><br>

Salvataggio del file:<br>
Premere 2 volte ESC e digitare <b>:wq</b><br><br>

-Configurazione del Pluto:<br>
Dalla pagina del Controller selezionare la modalità modalità "<b>Repeater</b>". Se hai il link dello streaming http del ricevitore inseriscilo ma non è necessario. In ogni caso il beacon della IP Camera partirà ai minuti configurati nell'apposita sezione<br>

Note: Se non si possiede un ricevitore Octagon SF8008 è possibile utilizzare in alternativa un Raspberry con FFMPEG installato<br></td>
</div>
</section>
<br><hr><br>

<section style=" text-align:left;">
<div><h3><b>IS0GRB Pluto DATV Patch - IP Camera configuration guide for beacon mode</b></h3></div>
</section>
<br><hr>
<section>
<div>In order to configure an IP camera that normally supports the RTSP protocol, it is necessary to have an Octagon SF8008 receiver or a Raspberry<br>
Preliminary configurations: Set static IP and install FFMPEG among the additional receiver packages. By default it is not installed on the OpenATV firmware<br>
Below is an example if the Octagon SF8008 receiver is used<br>
Log in to the receiver in SSH:<br><br>
login: root<br>
passwd: (press ENTER)<br><br>
# <i><b>cd /etc/init.d</b></i><br>
# <i><b>touch check-ipcamera.sh</b></i><br>
# <i><b>chmod 755 check-ipcamera.sh</b></i><br>
# <i><b>vi check-ipcamera.sh</b></i><br><br>

Now put these commands inside the check-ipcamera.sh file:<br>
<br><hr>

#!/bin/sh<br><br>

pidffmpeg=$(ps aux | grep ffmpeg | grep -v grep)<br>
if [ "$pidffmpeg" = "" ] ; then<br>
killall ffmpeg<br>
/usr/bin/ffmpeg -y -rtsp_transport tcp -i rtsp://192.168.1.80:554/11 -vcodec copy -acodec copy -f mpegts udp://192.168.1.101:8282<br>
fi<br>
exit<br>

<br><hr>

-(192.168.1.80 is the IP of the camera)<br>
-(192.168.1.101 is the IP of the Pluto connected via LAN)<br>
-(rtsp: //192.168.1.80: 554/11 is the streaming address of the IP camera)<br>
-(the example refers to an IP camera brand SV3C model B06POE-1080-HX)<br>
-(On this site it is possible to obtain the streaming address based on your SV3C camera: https://www.ispyconnect.com/camera/sv3c)<br>

Save the file:<br>
Press ESC twice and type <b>:wq</b><br><br>

<br><hr><br>

# <i><b>cd /etc</b></i><br>
# <i><b>vi crontab</b></i><br><br>

Add this line in /etc/crontab:<br><br>

* * * * * root /home/root/check-ipcamera.sh<br><br>

Save the file:<br>
Press ESC twice and type :wq<br><br>

-Pluto configuration:<br>
From the Controller page select the "<b>Repeater</b>" mode. If you have the receiver's http streaming link, enter it but it is not necessary. In any case, the beacon of the IP Camera will start at the minutes configured in the appropriate section<br>

Notes: If you do not have an Octagon SF8008 receiver, you can alternatively use a Raspberry with FFMPEG installed<br></td>
</div>
</section>
<br>

</body>
</html>

